<template>
  <LayoutMain>
    <section>
      <!--TÍTULO SECCIÓN-->
      <b-overlay :show="isCategoryLoading||isCardLoading" rounded="sm">
      <b-container>
        <b-row align-h="center">
          <b-col cols="12">
            <TitleShape :title="'Anadir carta a ' + currentCategory.title" />
          </b-col>
        </b-row>
      </b-container>
      <!--SI ENTRO EN MODO EDITAR CARGO EL FORMULARIO-->
      <div class="color-wrapper">
        <b-container>
            <b-form-row class="justify-content-center text-center">
                <b-col cols="6">
                <b-form @submit="onSubmit" enctype="multipart/form-data">
                    <b-form-group>
                    <ImageProfile  :src="imageSrc" size="6rem" />
                    </b-form-group>
                    <!-- Buscador de imágenes. Aquí llamo al evento @change para obtener el archivo seleccionado-->
                    <b-form-group label-for="image">
                    <b-form-file v-model="imageFile" @change="getImage" class="buscador" ></b-form-file>
                    </b-form-group>

                    <b-form-group>
                    <b-form-input v-model="cardForm.title" placeholder="Título de la carta"></b-form-input>
                    </b-form-group>
                    <b-form-group>
                    <b-form-input v-model="cardForm.year" placeholder="Año de la carta"></b-form-input>
                    </b-form-group>

                    <b-form-group>
                    <b-form-textarea v-model="cardForm.description" placeholder="Introduce una descripción"></b-form-textarea>
                    </b-form-group>

                    <b-container>
                    <b-row>
                        <b-col cols="6">
                        <b-button size="lg" v-on:click="$router.go(-1)" variant="secondary" >Cancelar</b-button>
                        </b-col>
                        <b-col cols="6">
                        <b-button size="lg" type="submit" variant="primary">Guardar</b-button>
                        </b-col>
                    </b-row>
                    </b-container>
                </b-form>
                </b-col>
            </b-form-row>          
        </b-container>
        </div>
        </b-overlay>      
    </section>
  </LayoutMain>
</template>

<script>
// @ is an alias to /src
import LayoutMain from "@/components/layouts/Main.vue";
import TitleShape from "@/components/TitleShape.vue";
import ButtonEdit from "@/components/ButtonEdit.vue";
import ImageProfile from "@/components/ImageProfile.vue";
import { mapState, mapGetters } from "vuex";

export default {
  name: "home",
  components: {
    LayoutMain,
    TitleShape,
    ButtonEdit,
    ImageProfile
  },
  //En 'computed' es donde se almacenan los datos que pueden sufrir cambios.
  computed: {
    //A mapState le tengo que pasar el nombre del módulo, en este caso 'user' y la propiedad con los datos que quiero tener a mi disposición
    //profile el la propiedad que me dispone de los datos del usaurio X.
    ...mapGetters("category",{"isCategoryLoading": "isLoading"}),   
    ...mapGetters("card",{"isCardLoading": "isLoading"}),
    imageSrc(){
        //Modo editar
        if(this.image){
          return this.image;
        } else{
            return require('@/assets/img/default.png');
        }
    }
  },
  props: ["category_id"],
  data() {
    return {
      show: true,  
      image: '',
      imageFile: null,
      currentCategory: {},
      cardForm: {
          title: "",
          description: "",
          year: ""
      }
    };
  },
  mounted() {
    this.$store.dispatch("category/show", {id: this.category_id}).then(resp => {
      this.currentCategory = resp.data
    })
  },  
  methods: {
    onSubmit(evt) {
      evt.preventDefault();
      //Preparo un new formData.
      let formData = new FormData();
      //Agrego mediante "append" los valores del formulario al nuevo formData
      if(this.imageFile){
        formData.append('image', this.imageFile);
      }
      formData.append('title', this.cardForm.title);
      formData.append('description', this.cardForm.description);
      formData.append('year', this.cardForm.year);
      formData.append('category_id', this.category_id);
      
      this.$store.dispatch('card/store', {formData} ).then(result => {
        //Con un toast muestro un mensaje para indicar que se han guardado los cambios
        this.$router.go(-1)
        this.$root.$bvToast.toast(`Carta creada con éxito`, {
            title: 'Guardado',
            autoHideDelay: 5000,
            variant: 'success'
          })          
      }).catch(
        (error) => {
          //      
          Object.entries(error.errors).forEach(([key, msgs]) => {
            msgs.forEach((msg) => {
              this.$root.$bvToast.toast(msg, {
                title: 'Error',
                autoHideDelay: 5000,
                variant: 'danger'
              })
            })
          });
          
        }
      )
    },
    //Función para obtener el archivo seleccionado. Le paso 'e' que hace referencia al evento
    getImage(e){
      //Guardo el archivo
      let file = e.target.files[0];
      //Asigno a la propiedad 'image' del data el archivo.
      if (file) {
        this.imageFile = file;
        this.loadImage(file);
      }
    },

    //Función para cargar la imagen seleccionada para presentarla
    loadImage(file){
      //Preparo una variable con la clase FileReader. Esto me permitirá obtener la ruta del archivo así como otros parámetros 
      let reader = new FileReader();
      //La 'e' hace referencia al archivo 'file'
      reader.onload = (e) => {
        this.image = e.target.result;
      }
      //De esta forma puedo emplear el archivo en el formulario.
      reader.readAsDataURL(file);
    }
  }
};
</script>


